﻿@page "/admin/tasks/import"

@using Microsoft.Extensions.Localization
@using Microsoft.EntityFrameworkCore
@using OWebApplication.Operators
@using System.Threading
@using System.IO
@using Overtest.SharedLibraries.ProgrammingTasksShared.Operators

@implements IDisposable

@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IStringLocalizer<ImportProgrammingTasks> _localizer
@inject NavigationManager _navigationManager
@inject UserAccessControlOperator _userAccessControlOperator
@inject UserManager<User> _userManager

@inject IDialogService _dialogService
@inject ISnackbar _snackbar

<MudContainer MaxWidth="MaxWidth.Large" Class="my-3">
    <MudText Typo="Typo.h5" Style="font-weight: bold; line-height: 1;">
        @_localizer["Імпорт завдань"]
    </MudText>
</MudContainer>

<style>
    .upload-panel {
        position: absolute;
        width: 100%;
        top: 0; bottom: 0;
        left: 0; right: 0;
        cursor: pointer;
        z-index: 3;
    }
</style>

<InputFile OnChange="UploadProgrammingTaskArchivesAsync" id="data-package-upload-input" accept=".zip" multiple hidden/>

<MudContainer MaxWidth="MaxWidth.Large" Class="my-3">
    <MudAlert Severity="Severity.Info">
        <strong>@_localizer["Зверніть увагу!"]</strong>
        @_localizer["Будьте обережними, імпортуючи завдання, отримані із сторонніх джерел - ретельно перевіряйте зміст усіх завантажуваних архівів."]
    </MudAlert>
</MudContainer>

<MudContainer MaxWidth="MaxWidth.Large" Class="my-3">
    @if (!_stylizeHasFileUploadStarted)
    {
        <MudPaper Outlined="@(!_stylizeHasFileDragDropStarted)" Class="px-4 py-10 " Style="position: relative; text-align: center;"
                  Elevation="@(_stylizeHasFileDragDropStarted ? 5 : 0)"
                  @ondragenter="@(() => _stylizeHasFileDragDropStarted = true)"
                  @ondragleave="@(() => _stylizeHasFileDragDropStarted = false)"
                  @ondragend="@(() => _stylizeHasFileDragDropStarted = false)">
            <MudButton HtmlTag="label" for="data-package-upload-input" type="button" Class="upload-panel"></MudButton>
            <MudText Typo="Typo.h6" Style="font-weight: bold;">@_localizer["Оберіть файли або перетягніть його"]</MudText>
            <MudText Typo="Typo.subtitle2" Style="font-weight: normal;">@_localizer["Це мають бути архіви формату *.zip, які містять конфігурацію завданнь."]</MudText>
        </MudPaper>
    }
    else
    {
        <MudPaper Outlined="true" Class="px-4 py-10" Style="text-align: center">
                
        </MudPaper>
    }
</MudContainer>

<MudContainer MaxWidth="MaxWidth.Large" Class="my-3">
    @if (_uploadedFiles is not null)
    {
        <MudTable Items="@_uploadedFiles" Hover="true" Breakpoint="Breakpoint.None" Loading="@_stylizeHasFileUploadStarted" LoadingProgressColor="Color.Info">
            <HeaderContent>
                <MudTh>@_localizer["Назва файлу"]</MudTh>
                <MudTh Style="text-align: center;">@_localizer["Статус"]</MudTh>
                <MudTh Style="text-align: center;">@_localizer["Опис помилки"]</MudTh>
            </HeaderContent>
            <RowTemplate>
                <MudTd DataLabel="@_localizer["Назва файлу"]">@context.DisplayName</MudTd>
                <MudTd DataLabel="@_localizer["Статус"]" Style="text-align: center;">
                    @if (context.Status == UploadedFileStatus.Failed)
                    {
                        <MudChip Color="Color.Error">@_localizer["Виникла помилка"]</MudChip>
                    }
                    else if (context.Status == UploadedFileStatus.Success)
                    {
                        <MudChip Color="Color.Success">@_localizer["Успішно завершено"]</MudChip>
                    }
                    else
                    {
                        <MudChip>@context.Status.ToString()</MudChip>
                    }
                </MudTd>
                <MudTd DataLabel="@_localizer["Опис помилки"]" Style="text-align: center;">
                    @if (context.ImportError == ProgrammingTasksImportOperator.ImportError.NoErrorsFound)
                    {
                        <MudChip Color="Color.Success">@_localizer["Відсутні помилки"]</MudChip>
                    }
                    else
                    {
                        <MudChip Color="Color.Error">@context.ImportError.ToString()</MudChip>
                    }
                </MudTd>
            </RowTemplate>
        </MudTable>
    }
</MudContainer>

@code {
    private SemaphoreSlim _semaphore;
    private readonly CancellationTokenSource _cancellationTokenSource = new();

    private const int MaxUploadedFilesCount = 20;
    private const int MaxFileUploadSize = 100 * 1024 * 1024;

    private List<UploadedFileInfo> _uploadedFiles;
    
    private bool _stylizeHasFileDragDropStarted;
    private bool _stylizeHasFileUploadStarted;

    protected override async Task OnInitializedAsync()
    {
        _semaphore = new SemaphoreSlim(1, 1);

        _uploadedFiles = null;
        
        // Stylization
        _stylizeHasFileDragDropStarted = false;
        _stylizeHasFileUploadStarted = false;
        
        var authenticationState = await _authenticationStateProvider.GetAuthenticationStateAsync();
        var currentUserId = new Guid(_userManager.GetUserId(authenticationState.User));
        
        await using var databaseContext = _dbContextFactory.CreateDbContext();

        if (!await _userAccessControlOperator.HasUserTypeAsync(databaseContext, currentUserId, UserType.SuperUser))
        {
            _snackbar.Add(_localizer["Ви не маєте необхідного рівня доступу для перегляду ціє сторінки!"],
                Severity.Error, options => options.CloseAfterNavigation = false);
            _navigationManager.NavigateTo("/tasks/archive");
            // ReSharper disable once RedundantJumpStatement
            return;
        }
    }
    
    private async Task UploadProgrammingTaskArchivesAsync(InputFileChangeEventArgs e)
    {
        if (_stylizeHasFileUploadStarted)
            return;
        
        if (e.FileCount < 1)
            return;

        await _semaphore.WaitAsync();
        _uploadedFiles = null;
        _stylizeHasFileUploadStarted = true;
        
        StateHasChanged();

        try
        {
            var uploadedFilesInformation = e.GetMultipleFiles(MaxUploadedFilesCount);

            if (_cancellationTokenSource.IsCancellationRequested)
                return;
            
            _uploadedFiles = new List<UploadedFileInfo>();
            foreach (var uploadedFile in uploadedFilesInformation)
            {
                _cancellationTokenSource.Token.ThrowIfCancellationRequested();

                // Allow only files with *.zip extension and content type
                var isDenied = !uploadedFile.Name.ToLower().EndsWith(".zip")
                               || (uploadedFile.ContentType.ToLower()
                                   is not "application/zip"
                                       and not "application/octet-stream"
                                       and not "application/x-zip-compressed");
                
                var uploadedFileInfo = new UploadedFileInfo
                {
                    DisplayName = uploadedFile.Name,
                    Status = isDenied ? UploadedFileStatus.Failed : UploadedFileStatus.Waiting
                };
                
                if (!isDenied)
                {
                    uploadedFileInfo.TempFileName = Path.GetTempFileName();
                    await using var fileStream = new FileStream(uploadedFileInfo.TempFileName,
                        FileMode.OpenOrCreate, FileAccess.ReadWrite);
                    await uploadedFile.OpenReadStream(MaxFileUploadSize).CopyToAsync(fileStream);
                }
                else
                {
                    _snackbar.Add(_localizer["Обраний вами файл {0} не є архівом формату ZIP!", uploadedFile.Name], Severity.Error);
                    uploadedFileInfo.ImportError = ProgrammingTasksImportOperator.ImportError.ArchiveCorrupted;
                }

                _uploadedFiles.Add(uploadedFileInfo);
                StateHasChanged();
            }

            await using var databaseContext = _dbContextFactory.CreateDbContext();
            var tasksImportOperator = new ProgrammingTasksImportOperator();

            foreach (var uploadedFileInfo in _uploadedFiles)
            {
                _cancellationTokenSource.Token.ThrowIfCancellationRequested();

                if (uploadedFileInfo.Status == UploadedFileStatus.Failed)
                    continue;

                uploadedFileInfo.Status = UploadedFileStatus.Importing;
                
                StateHasChanged();

                var (programmingTaskId, importError) = await tasksImportOperator.TryImportProgrammingTaskAsync(
                    uploadedFileInfo.TempFileName, databaseContext, _cancellationTokenSource.Token);

                uploadedFileInfo.Status = importError == ProgrammingTasksImportOperator.ImportError.NoErrorsFound
                    ? UploadedFileStatus.Success
                    : UploadedFileStatus.Failed;
                uploadedFileInfo.ImportError = importError;
                uploadedFileInfo.ProgrammingTaskId = programmingTaskId;
                
                StateHasChanged();
            }
        }
        catch (Exception)
        {
            _uploadedFiles = null;
            _snackbar.Add(_localizer[
                "У процесі імпорту архівів з завданнями виникла непередбачена критична помилка. " +
                "Радимо звернутися за допомогою до технічної підтримки."], Severity.Error);
        }
        finally
        {
            EnsureTempFilesDeleted();
            _stylizeHasFileUploadStarted = false;
            _semaphore.Release();
        }

        void EnsureTempFilesDeleted()
        {
            if (_uploadedFiles is null)
                return;
            foreach (var fileInfo in _uploadedFiles.Where(fileInfo => !string.IsNullOrWhiteSpace(fileInfo.TempFileName)))
            {
                try { File.Delete(fileInfo.TempFileName); }
                catch (Exception) { /* Ignore all exceptions */ }
            }
        }
    }
    
    public void Dispose()
    {
        _cancellationTokenSource.Cancel();
        _cancellationTokenSource.Dispose();
    }

    private class UploadedFileInfo
    {
        public UploadedFileInfo()
        {
            TempFileName = null;
            ImportError = ProgrammingTasksImportOperator.ImportError.NoErrorsFound;
            ProgrammingTaskId = null;
        }

        public string DisplayName { get; set; }
        public UploadedFileStatus Status { get; set; }
        public string TempFileName { get; set; }
        public ProgrammingTasksImportOperator.ImportError ImportError { get; set; }
        public Guid? ProgrammingTaskId { get; set; }
    }

    private enum UploadedFileStatus
    {
        Waiting,
        Importing,
        Success,
        Failed
    }
}